<template>
  <UDashboardNavbar title="Fahrten" :badge="filteredRows.length">
    <template #right>
      <UInput
          id="searchinput"
          v-model="searchString"
          icon="i-heroicons-funnel"
          autocomplete="off"
          placeholder="Suche..."
          class="hidden lg:block"
          @keydown.esc="$event.target.blur()"
      >
        <template #trailing>
          <UKbd value="/" />
        </template>
      </UInput>

<!--      <UButton @click="router.push(`/vehicles/create`)">+ Fahrzeug</UButton>-->
    </template>
  </UDashboardNavbar>

  <UDashboardToolbar>
    <template #right>
      <USelectMenu
          v-model="selectedColumns"
          icon="i-heroicons-adjustments-horizontal-solid"
          :options="templateColumns"
          multiple
          class="hidden lg:block"
          by="key"
      >
        <template #label>
          Spalten
        </template>
      </USelectMenu>
    </template>
  </UDashboardToolbar>
  <UTable
      :rows="filteredRows"
      :columns="columns"
      class="w-full"
      :ui="{ divide: 'divide-gray-200 dark:divide-gray-800' }"
      @select="(i) => router.push(`/trackingTrips/show/${i.id}`) "
      :empty-state="{ icon: 'i-heroicons-circle-stack-20-solid', label: 'Keine Fahrten anzuzeigen' }"
  >
    <template #fixed-data="{row}">
      <UIcon name="i-heroicons-lock-closed" v-if="row.fixed"/>
      <div v-else></div>
    </template>
    <template #licensePlate-data="{row}">
      <span v-if="row === filteredRows[selectedItem]" class="font-bold text-primary-500">{{row.vehicle.licensePlate}}</span>
      <span v-else>{{row.vehicle.licensePlate}}</span>
    </template>
    <template #startTime-data="{row}">
      {{dayjs(row.startTime).format("DD.MM.YY HH:mm")}}
    </template>
    <template #endTime-data="{row}">
      {{dayjs(row.endTime).format("DD.MM.YY HH:mm")}}
    </template>
    <template #distance-data="{row}">
      {{row.distance > 0 ? (row.distance/1000).toFixed(2) : 0 }} km
    </template>
  </UTable>
</template>

<script setup>

import dayjs from "dayjs";

definePageMeta({
  middleware: "auth"
})

defineShortcuts({
  '/': () => {
    //console.log(searchinput)
    //searchinput.value.focus()
    document.getElementById("searchinput").focus()
  },
  'Enter': {
    usingInput: true,
    handler: () => {
      router.push(`/trackingTrips/show/${filteredRows.value[selectedItem.value].id}`)
    }
  },
  'arrowdown': () => {
    if(selectedItem.value < filteredRows.value.length - 1) {
      selectedItem.value += 1
    } else {
      selectedItem.value = 0
    }
  },
  'arrowup': () => {
    if(selectedItem.value === 0) {
      selectedItem.value = filteredRows.value.length - 1
    } else {
      selectedItem.value -= 1
    }
  }
})

const dataStore = useDataStore()
const router = useRouter()

const items = ref([])
const selectedItem = ref(0)

const setupPage = async () => {
  items.value = await useSupabaseSelect("trackingtrips","*, trackingDevice(*), vehicle (*)","startTime",false)
}

setupPage()

const templateColumns = [
  {
    key: 'fixed',
    label: ""
  },
  {
    key: 'licensePlate',
    label: "Kennzeichen:",
    sortable: true
  },
  {
    key: "type",
    label: "Typ:",
    sortable: true
  },
  {
    key: "startTime",
    label: "Startzeit:",
    sortable: true
  },
  {
    key: "endTime",
    label: "Endzeit:",
    sortable: true
  },
  {
    key: "distance",
    label: "Entfernung:",
    sortable: true
  }
]
const selectedColumns = ref(templateColumns)
const columns = computed(() => templateColumns.filter((column) => selectedColumns.value.includes(column)))

const searchString = ref('')

const filteredRows = computed(() => {
  return useSearch(searchString.value, items.value)
})
</script>

<style scoped>

</style>